<template>
  <div
    class="w-fit"
    :class="[compactClass(), stateColor()]"
  >
    <div
      v-if="dot"
      :class="[dotClass()]"
    />
    <p class="text-sm font-medium">
      {{text}}
    </p>
  </div>
</template>

<script setup>
const props = defineProps({
  text: {
    type: String,
    default: 'Status'
  },
  dot: {
    type: Boolean,
    default: false
  },
  state: {
    type: String,
    default: 'neutral'
  },
  compact: {
    type: Boolean,
    default: false
  },
  success: {
    type: Boolean,
    default: false
  },
  warning: {
    type: Boolean,
    default: false
  },
  error: {
    type: Boolean,
    default: false
  },
  disabled: {
    type: Boolean,
    default: false
  },
  flat: {
    type: Boolean,
    default: false
  }
})

const compactClass = () => {
  if (props.compact) {
    return `flex gap-2 h-[20px] py-[2px] px-2 items-center rounded ${props.flat ? null : 'border-[0.5px]' }`
  } else {
    return `flex gap-2 h-[26px] py-[5px] px-2 items-center rounded ${props.flat ? null : 'border-[0.5px]' }`
  }
}

const stateColor = () => {
  if (props.success) {
    return `!text-positive-green border-positive-green ${props.flat ? null : 'bg-[#F2F9F2]' }`
  } else if (props.warning) {
    return `text-medium-orange border-medium-orange ${props.flat ? null : 'bg-[#FFFAEF]' }`
  } else if (props.error) {
    return `text-negative-red border-negative-red ${props.flat ? null : 'bg-[#FFEFEF]' }`
  } else if (props.disabled) {
    return `text-middle-grey border-middle-grey ${props.flat ? null : ' bg-very-light-grey' }`
  } else {
    return `text-fake-black border-fake-black ${props.flat ? null : ' bg-very-light-grey' }`
  }
}

const dotClass = () => {
  if (props.success) {
    return 'rounded-full h-2 w-2 bg-positive-green'
  } else if (props.warning) {
    return 'rounded-full h-2 w-2 bg-medium-orange'
  } else if (props.error) {
    return 'rounded-full h-2 w-2 bg-negative-red'
  } else if (props.disabled) {
    return 'rounded-full h-2 w-2 bg-middle-grey'
  } else {
    return 'rounded-full h-2 w-2 bg-fake-black'
  }
}

</script>

<style scoped>

</style>